Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Definition not_zero : nat -> Prop := fun (n:nat) => match_nat_type (Prop) connectives.False (fun (p:nat) => connectives.True) n.
Parameter le : nat -> nat -> Prop.
Axiom le_n : forall (n:nat), le n n.
Axiom le_S : forall (n:nat), forall (m:nat), (le n m) -> le n (S m).
Axiom le_ind : forall (n:nat), forall (Q:(nat -> Prop)), (Q n) -> (forall (m:nat), (le n m) -> (Q m) -> Q (S m)) -> forall (m:nat), (le n m) -> Q m.
Definition lt : nat -> nat -> Prop := fun (n:nat) => fun (m:nat) => le (S n) m.
Definition nat_elim2 : forall (R:(nat -> nat -> Prop)), (forall (n:nat), R O n) -> (forall (n:nat), R (S n) O) -> (forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) -> forall (n:nat), forall (m:nat), R n m := fun (R:nat -> nat -> Prop) => fun (ROn:forall (n:nat), R O n) => (fun (RSO:forall (n:nat), R (S n) O) => (fun (RSS:forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) => (fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), R _x_365 m)) (fun (m:nat) => (ROn) (m))) (fun (n0:nat) => fun (Rn0m:forall (m:nat), R n0 m) => (fun (m:nat) => ((((match_nat_prop) (fun (__:nat) => R (S n0) __)) ((RSO) (n0))) (fun (auto:nat) => (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
Definition pred_Sn : forall (n:nat), logic.eq (nat) n (pred (S n)) := fun (n:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (n)) (fun (y:nat) => logic.eq (nat) n y)) (((logic.refl) (nat)) (n)).
Definition lt_to_not_zero : forall (n:nat), forall (m:nat), (lt n m) -> not_zero m := fun (n:nat) => fun (m:nat) => fun (Hlt:lt n m) => (((((((le_ind) (S n)) (fun (x_417:nat) => not_zero x_417)) (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (n)) (fun (y:Prop) => y)) (connectives.I))) (fun (m0:nat) => fun (_x_419:le (S n) m0) => (fun (_x_421:not_zero m0) => (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (m0)) (fun (y:Prop) => y)) (connectives.I))))) (m)) (Hlt)).
Definition le_n_Sn : forall (n:nat), le n (S n) := fun (n:nat) => (((le_S) (n)) (n)) ((le_n) (n)).
Definition transitive_le : relations.transitive (nat) le := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (leab:le a b) => (fun (lebc:le b c) => (((((((le_ind) (b)) (fun (x_417:nat) => le a x_417)) (leab)) (fun (m:nat) => fun (_x_419:le b m) => (fun (_x_421:le a m) => ((((le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
Definition le_pred_n : forall (n:nat), le (pred n) n := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => le (pred _x_365) _x_365)) ((((((eq_match_nat_type_O) (nat)) (O)) (fun (p:nat) => p)) (fun (y:nat) => le (match_nat_type (nat) O (fun (p:nat) => p) O) y)) ((le_n) (pred O)))) (fun (x_366:nat) => fun (_x_368:le (pred x_366) x_366) => (((((((eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (x_366)) (fun (y:nat) => le (pred (S x_366)) (S y))) ((le_n_Sn) (pred (S x_366)))))) (n).
Definition monotonic_pred : relations.monotonic (nat) le pred := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (pred n) (pred x_417))) ((le_n) (pred n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (pred n) (pred m0)) => ((((((transitive_le) (pred n)) (n)) (pred (S m0))) ((le_pred_n) (n))) (((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (m0)) (fun (y:nat) => le n y)) (_x_419)))))) (m)) (lenm)).
Definition not_le_Sn_O : forall (n:nat), connectives.Not (le (S n) O) := fun (n:nat) => ((connectives.nmk) (le (S n) O)) (fun (Hlen0:le (S n) O) => ((((((eq_match_nat_type_O) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (fun (y:Prop) => y)) ((((lt_to_not_zero) (n)) (O)) (Hlen0)))).
Definition le_n_O_to_eq : forall (n:nat), (le n O) -> logic.eq (nat) O n := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => (le __ O) -> logic.eq (nat) O __)) (fun (auto:le O O) => (((logic.refl) (nat)) (O)))) (fun (a:nat) => fun (abs:le (S a) O) => (((connectives.falsity) (logic.eq (nat) O (S a))) ((((logic.absurd) (le (S a) O)) (abs)) ((not_le_Sn_O) (a)))))) (n).
Definition le_to_le_to_eq : forall (n:nat), forall (m:nat), (le n m) -> (le m n) -> logic.eq (nat) n m := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => (le __ _0) -> (le _0 __) -> logic.eq (nat) __ _0)) (fun (n:nat) => fun (auto:le O n) => (fun (auto':le n O) => (((((logic.sym_eq) (nat)) (n)) (O)) (((((logic.sym_eq) (nat)) (O)) (n)) (((((logic.eq_coerc) (logic.eq (nat) O n)) (logic.eq (nat) O n)) (((le_n_O_to_eq) (n)) (auto'))) (((logic.refl) (Prop)) (logic.eq (nat) O n)))))))) (fun (n:nat) => fun (auto:le (S n) O) => (fun (auto':le O (S n)) => (((((logic.sym_eq) (nat)) (O)) (S n)) (((le_n_O_to_eq) (S n)) (auto)))))) (fun (n:nat) => fun (m:nat) => fun (auto:(le n m) -> (le m n) -> logic.eq (nat) n m) => (fun (auto':le (S n) (S m)) => (fun (auto'':le (S m) (S n)) => (((((((logic.eq_f) (nat)) (nat)) (S)) (n)) (m)) (((auto) (((((logic.eq_coerc) (le (pred (S n)) (pred (S m)))) (le n m)) ((((monotonic_pred) (S n)) (S m)) (auto'))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S m))) (le n m))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le n __) (le n m))) (((logic.refl) (Prop)) (le n m))) (pred (S m))) ((pred_Sn) (m)))) (pred (S n))) ((pred_Sn) (n))))) (((((logic.eq_coerc) (le (pred (S m)) (pred (S n)))) (le m n)) ((((monotonic_pred) (S m)) (S n)) (auto''))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S n))) (le m n))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le m __) (le m n))) (((logic.refl) (Prop)) (le m n))) (pred (S n))) ((pred_Sn) (n)))) (pred (S m))) ((pred_Sn) (m))))))))).
